#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>
#include <sys/auxv.h>

extern void test (void);
extern void secondary (void);

int
main (void)
{
  void *dso;
  void (*func) (void);
  unsigned long ret;
  ret = getauxval (AT_SECURE);
  printf ("INFO: AT_SECURE is %ld\n", ret);

  dso = dlopen ("libsecondary.so", RTLD_NOW|RTLD_GLOBAL);
  if (dso == NULL)
    {
      printf ("FAIL: Failed to dlopen library.\n");
    }
  else
    {
      printf ("PASS: Correctly dlopen-ed library.\n");
    }
  func = dlsym (dso, "secondary");
  func ();
  test ();
  dlclose (dso);
  return 0;
}
