#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>
#include <sys/auxv.h>

extern void secondary (void);

int
main (void)
{
  void *dso;
  void (*func) (void);
  unsigned long ret;
  ret = getauxval (AT_SECURE);
  printf ("INFO: AT_SECURE is %ld\n", ret);

  dso = dlopen ("libsecondary.so", RTLD_NOW|RTLD_GLOBAL);
  if (dso == NULL)
    {
      printf (MSGDSOFAIL);
      return 0;
    }
  else
    {
      printf (MSGDSOLOAD);
    }
  func = dlsym (dso, "secondary");
  func ();
  dlclose (dso);
  return 0;
}
